<template>
	<div class="row">
		<div class="col">
			<AutocompleteNombreApellido v-model="persona" />
		</div>
		<div class="col-3">
			<label for="estado" class="form-label text-secondary">Estados</label>
			<select
				id="estado"
				class="form-select form-select-sm"
				aria-label="Estado"
				v-model="estado"
			>
				<option :value="null"></option>
				<option
					v-for="estado in estados"
					:value="estado"
					:key="estado.id_estado"
				>
					{{ estado.d_estado }}
				</option>
			</select>
		</div>
		<div class="col">
			<button
				type="button"
				class="btn btn-principal mt-45"
				@click="ejecFormBusqueda()"
			>
				Buscar
			</button>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import shared from "@/shared.js";
import AutocompleteNombreApellido from "./AutocompleteNombreApellido.vue";
import { mapStores, mapState } from "pinia";
import { useTitulosStore } from "@/stores/titulos";
import { useAuxFormDataStore } from "@/stores/auxFormData";

import type { Persona } from "@/entities/Persona";
import type { EstadoRef as EstadoRefType } from "@/entities/EstadoRef";

const { loading } = shared();

export default defineComponent({
	name: "BusquedaTitulos",
	components: {
		AutocompleteNombreApellido,
	},
	data() {
		return {
			persona: undefined as Persona | undefined,
			estado: null as EstadoRefType | null,
		};
	},
	computed: {
		...mapStores(useTitulosStore),
		...mapState(useAuxFormDataStore, {
			estados: "estadoTitulos",
		}),
	},
	mounted() {
		this.estado = null;
	},
	methods: {
		async ejecFormBusqueda() {
			loading.show();
			await this.titulosStore.updateListado({
				persona: this.persona,
				estado: this.estado,
			});
			loading.hide();
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.btn-principal {
	background: #00a5bd !important;
	color: #fff !important;
}
.mt-45 {
	margin-top: 45px !important;
}
</style>
